/*
 * Cgaufin and Mysil 
 * See Microchip Forum https://www.microchip.com/forums/FindPost/1118405 
 */
#include <stdint.h>
#include <stdio.h>
#include <xc.h>
#include "mcc_generated_files/mcc.h"

#ifndef   DIAG2_SetHigh					/* If Diagnostic LED is Not available */
  #define DIAG2_SetHigh()				/* then define macro as empty. */
  #define DIAG2_SetLow()
#endif

const char *Text[112] = {
//	" ", " ", " ", " ", " ", " ", " ", " ",		/* 0x00;  0 thru 7 Reserved */
//	 " ", " ", " ", " ", " ", " ", " ", " ",	/* 0x08;  8 */
	 " ", " ", " ", " ", " ", " ", "PIC16", " ",	/* 0x10; 16 */
	 "PIC18", " ", " ", " ", " ", " ", " ", " ",	/* 0x18; 24 */
	 "GPIO14",									/* 0x20; 32 */
	      " ", " ", " ", " ", " ", " ", " ",	/* 0x21; 33 */
	 "LK204   LCD Display by Matrix Orbital",	/* 0x28; 40 */
	 " ", " ", " ", " ", " ", " ", " ",			/* 0x29; 41 */
	 " ", " ", " ", " ", " ", " ", " ", " ",	/* 0x30; 48, */
	 "RLY08   Relay card",						/* 0x38; 56 */
	      " ", " ", " ", " ", " ", " ", " ",	/* 0x39; 57 */
	 " ", " ", " ", " ", " ", " ", " ", " ",	/* 0x40; 64, */
	 "MCP9801 Temperature sensor",				/* 0x48; 72 */
	 "MCP9801 Temperature sensor 1",			/* 0x49; 73 */
	 "MCP9801 Temperature sensor 2",			/* 0x4A; 74 */
	 "MCP9801 Temperature sensor 3",			/* 0x4B; 75 */
	 "MCP9801 Temperature sensor 4",			/* 0x4C; 76 */
	 "MCP9801 Temperature sensor 5",			/* 0x4D; 77 */
	 "MCP9801 Temperature sensor 6",			/* 0x4E; 78 */
	 "MCP9801 Temperature sensor 7",			/* 0x4F; 79 */
	 "EEPROM  Memory", " ", " ", " ", " ", " ",	/* 0x50; 80, */
	 "24LC512 Memory",							/* 0x56; 86, */
	 "EEPROM  Memory",							/* 0x57; 87, */
	 " ", " ", " ", " ", " ", " ", " ", " ",	/* 0x58; 88 */
	 "MPL3115 barometer/altimeter",				/* 0x60; 96, */
	      " ",									/* 0x61; 97, */
	 "CMPS03  Magnetometer compass",			/* 0x62; 98, */
	                " ", " ", " ", " ", " ",	/* 0x63; 99, */
	 "MCP3426 Voltage sensor",					/* 0x68; 104 */
	 "MCP3426 Voltage sensor",					/* 0x69; 105 */
	           " ", " ", " ", " ", " ",			/* 0x6A; 106 */
	 "RTCC    Clock and calendar"				/* 0x6F; 111 */
//	," ", " ", " ", " ", " ", " ", " ", " " 	/* 0x70; 112 thru 119*/
};												/* 0x78 thru 0x7F Reserved. */

const char *Status[96] = {
	"I2C_NOERR","I2C_BUSY",  "I2C_FAIL", " ",				/* 0x00; thru  3, as generated by MCC */
//	"I2C_BUSY", " ", "I2C_NOERR",  "I2C_FAIL",				/* 0x00; thru  3, when modified by Mysil. */
//	" ", " ", " ", " ",										/* 0x04;  0 thru 7 */
//	" ", " ", " ", " ", " ", " ", " ", " ",					/* 0x08;  8 */
//	" ", " ", " ", " ", " ", " ", " ", " ",					/* 0x10; 16 */
//	" ", " ", " ", " ", " ", " ", " ", " ",					/* 0x18; 24 */
//	" ", " ", " ", " ", " ", " ", " ", " ",					/* 0x20; 32 */
//	" ", " ", " ", " ", " ", " ", " ", " ",					/* 0x28; 40 */
//	"I2C_MESSAGE_SETUP", " ", " ", " ",						/* 0x30; 48, */
//	"I2C_MESSAGE_PENDING",	" ", " ", " ",					/* 0x34; 52 */
//	"I2C_MESSAGE_WAIT", " ",								/* 0x38; 56 */
//					"I2C_MESSAGE_READY ", " ",				/* 0x3A; 58 */
//	"I2C_MESSAGE_RETRY",  " ", " ", " ",					/* 0x3C; 60, */
//	"I2C_MESSAGE_ACTIVE", " ",								/* 0x40; 64, */
//					"I2C_MESSAGE_COMPLETE",					/* 0x42; 66, */
//							"I2C_ERROR_FAIL",				/* 0x43; 67, */
//	" ",	" ",	" ",	"I2C_ERROR_ADDRESS_NACK",		/* 0x44; 68, */
//	" ",	" ",	" ",	"I2C_ERROR_DATA_NACK",			/* 0x48; 72 */
//	" ",	" ",	" ",									/* 0x4C; 76 */
//							"I2C_ERROR_QUEUE_FULL",			/* 0x4F; 79 */
//	" ",	" ",	" ",	"I2C_ERROR_BUS_COLLISION",		/* 0x50; 80, */
//	" ",	" ",	" ",									/* 0x54; 84, */
//							"I2C_ERROR_STUCK_START",		/* 0x57; 87, */
//	" ",	" ",	" ",	"I2C_ERROR_LOST_STATE",			/* 0x58; 88 */
//	" ",	" ",	" ",									/* 0x5C; 92 */
//							"I2C_ERROR_TIMEOUT"				/* 0x5F; 95 */
};												

/* ****************************************************************************/
/** This is a private  callback handler for use with I2C_check(...) function.
 * Argument:
 *  *Ptr   Callback payload pointer is used for address of nackFlag status value.
 * Return: enumeration code of type i2c_operations_t from i2c_master.h */
static  i2c2_operations_t  NackAddressHandler(void *Ptr)
{    /* Do something to notice that Address Nack have occurred. */
	uint8_t * nackFlag = Ptr;
    *nackFlag = 1;
    return I2C2_STOP;          /* Let driver proceed with Stop signal. */
}

/* *****************************************************************************
 *  nack = I2C_Probe( deviceAddress, &status); */
/** 
 * Description:
 *  Function to check if I2C device answer when called. 
 *	If driver is generated to use interrupts, repeat calling this function, 
 *  using the same deviceAddress argument, 
 *	until status argument return with value I2C_MESSAGE_COMPLETE 
 *	If status argument return with I2C_ERROR_ADDRESS_NACK, 
 *	then there was no response from this address.
 * Argument:
 *  deviceAddress       I2C 7-bit address of slave.
 *  *status             Pointer to progress status for use with non-blocking driver.     
 *  Return value == 0   I2C slave is present and responding.
 *               == 1   NACK returned, slave is not connected, or do not respond.
 */
uint8_t I2C_Probe( uint8_t  deviceAddress, i2c2_error_t* msgstat )
{//	i2c_error_t msgstat;
#define		Setup   1
#define		Working 2
#define		Done    3
	static uint8_t   State = Setup;	
	static uint8_t   NackFlag; 
	static uint8_t   dummy[2] = {0x00, 0x18};

	switch(State)
	{
	  case Setup:
	    NackFlag = 0;        /* Reset the flag, */
		while(I2C2_BUSY == (*msgstat = I2C2_Open(deviceAddress))); // sit here until we get the bus..

//		I2C2_SetBuffer(&dummy[0],2);		    /* This should work with i2c_master.c with no change. */
		I2C2_SetBuffer(&dummy[1],0);			/* Zero length transfer require modified driver i2c_master.c */
		I2C2_SetAddressNackCallback(NackAddressHandler, &NackFlag); /* Pointer to Flag as payload pointer. */
		
	
		*msgstat = I2C2_MasterOperation(0);	/* Start a I2C Write operation, same as I2C_MasterWrite. */
		if (*msgstat == I2C2_FAIL || I2C2_NOERR == *msgstat )
		{	State = Setup;	}			/* No break; here, pass on to I2C1_Close() */
		else	// if (I2C1_BUSY == *msgstat)
		{	State = Working;			
			break;
		}
	  case Working:
#if (1)										/* For Blocking mode, */
	    while(I2C2_BUSY == (*msgstat = I2C2_Close())); // sit here until finished.
#else
		/* In Non-blocking mode, come here occasionally to test progress. */
		*msgstat = I2C1_Close();
#endif
		if ( *msgstat == I2C2_FAIL)
			State = Setup;
		else if ( *msgstat == I2C2_BUSY)
			break;
		else
		{	State = Setup;
				DIAG2_SetHigh();		/* Cancel the Bug, Mysil. */
		}
		break;
		
	  case Done:
		State = Setup;
		break;
	  default:
		  State = Setup;
		  break;
	}
	return NackFlag;
}

/* *****************************************************************************
 *  I2C_AddressScan(); */
/**	Description:
 *  Function to scan a I2C bus for available devices.
 */
uint8_t I2C_AddressScan(uint8_t * Address)
{static	uint8_t address = 8, flag;
static	i2c2_error_t msgstat;

	if (*Address <= 8)
		address = 8;

	if (address == 8)
	{
		printf("I2C 7bit Address \r\n");
//		while (!UART2_is_tx_done()) NOP();	/* Wait until previous print is done. */
	}
	{				DIAG2_SetHigh();		/* Diagnostic timing signal. */
		flag = I2C_Probe( address, &msgstat);
					DIAG2_SetLow();		/* Diagnostic timing signal. */
		if (msgstat  == I2C2_BUSY) return 2;	//	if ((msgstat & I2C1_MASK) == I2C1_BUSY) return;
		{	if (flag)
			{	NOP();
			 	printf(" 0x%X No answer. \r\n", address);
			}
			else
			{	printf(" 0x%X %s responding. \r\n", address, Text[address - 0x10]);
			}
		}
		if (address < 119)
		{	address ++;
		    *Address = address;
			return flag;
		}
		else
		{	address = 8;
			return Done;
		}
	}
}
