/*
 *	Timer 6 for use as Bus Timeout for I2C driver,
 *  probably not needed when other mistakes are corrected.
 */
#include  <stdint.h>
#include <xc.h>
#include "mcc_generated_files/pin_manager.h"
#ifndef   DIAG0_Toggle
  #define DIAG0_Toggle()				/* Define as empty macro when not available. Mysil */
#endif
void Timer6_SetCallbackHandler(void (* CallbackHandler)(void));
static void Timer6_DefaultCallbackHandler(void);
										/* Pointer for Custom Callback function. */
static void (*TMR6_CallbackPointer)(void) = Timer6_DefaultCallbackHandler;

/* Timer 6 */
void Timer6_Initialize(void)
{
	T6CONbits.CKPS = 2;
	T6CONbits.OUTPS = 0;	/* No postscaler. */
	T6CLKbits.CS = 5;		/* MFINTOSC (500 kHz) */
	T6HLTbits.PSYNC = 1;
	T6HLTbits.MODE  = 0;
	T6PR = 255;				/* Free running. */ 
	T6CONbits.ON = 1;		/* Enable	*/
	PIR9bits.TMR6IF = 0; // Clear the interrupt flag
	PIE9bits.TMR6IE = 0;
	IPR9bits.TMR6IP = 0;	/* Low priority */
	
    // Set Default Interrupt Handler
    Timer6_SetCallbackHandler(Timer6_DefaultCallbackHandler);

}


void __interrupt(irq(IRQ_TMR6), base(0x0008), low_priority) TMR6_ISR(void)
{
	PIR9bits.TMR6IF = 0; // Clear the interrupt flag
	__builtin_software_breakpoint();
	DIAG0_Toggle();		// ISR code goes here
	if (TMR6_CallbackPointer)
		TMR6_CallbackPointer();

}
void Timer6_SetCallbackHandler(void (* CallbackHandler)(void))
{
	TMR6_CallbackPointer = CallbackHandler;
}

static void Timer6_DefaultCallbackHandler(void)
{
	Nop();			/* Interrupt Callback code here, */
					/* or make: void Timer6_Callback(void)
					 * in another context,
					 * and introduce by calling:
					 *    Timer6_SetCallbackHandler(Timer6_Callback); 
					 * Callback may then be canceled when not needed by calling:
					 *    Timer6_SetCallbackHandler(NULL); */
					/* When a custom Callback() function have been introduced, 
					 * then code in this Default function is no longer executed. */
}
