/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.7
        Device            :  PIC18F26K83
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

i2c2_address_t my_address=0x60;//1100 00 0
uint8_t my_reg=0x40; 
uint16_t my_data=0xFF; 
uint8_t my_array[3]={0x40,0x50,0x70};

#define SLAVE_ADDRESS     0x60                                                  

// Slave address, will be right-shifted by I2C driver = 0x40
// 128 bytes in array
#define SLAVE_EE_ADD      0x40 // 010 00 00 0 Only DAC ; 011 00 00 0                                  
#define PACKET_SIZE       0x80     
// Slave's beginning array address location
#define TRANS_CNT         0x81                                                  
uint8_t transArray[PACKET_SIZE] =                                               // Array that is written to the slave device
{
   0xA0, 0xB0, 0xC0, 0xD0, 0xE0, 0xF0, 0xA1, 0xB1, 0xC1, 0xD1, 0xE1, 0xF1,
   0xA2, 0xB2, 0xC2, 0xD2, 0xE2, 0xF2, 0xA3, 0xB3, 0xC3, 0xD3, 0xE3, 0xF3,
   0xA4, 0xB4, 0xC4, 0xD4, 0xE4, 0xF4, 0xA5, 0xB5, 0xC5, 0xD5, 0xE5, 0xF5,
   0xA6, 0xB6, 0xC6, 0xD6, 0xE6, 0xF6, 0xA7, 0xB7, 0xC7, 0xD7, 0xE7, 0xF7,
   0xA8, 0xB8, 0xC8, 0xD8, 0xE8, 0xF8, 0xA9, 0xB9, 0xC9, 0xD9, 0xE9, 0xF9,
   0xAA, 0xBA, 0xCA, 0xDA, 0xEA, 0xFA, 0xAB, 0xBB, 0xCB, 0xDB, 0xEB, 0xFB,
   0xAC, 0xBC, 0xCC, 0xDC, 0xEC, 0xFC, 0xAD, 0xBD, 0xCD, 0xDD, 0xED, 0xFD,
   0xAE, 0xBE, 0xCE, 0xDE, 0xEE, 0xFE, 0xAF, 0xBF, 0xCF, 0xDF, 0xEF, 0xFF,
   0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B,
   0x0C, 0x0D, 0x0E, 0x0F, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
   0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F
};
uint8_t RXArray[PACKET_SIZE];                                                   
void I2C2_Write2ByteRegister(i2c2_address_t address, uint8_t reg, uint16_t data);
void I2C2_ReadDataBlock(i2c2_address_t address, uint8_t reg, uint8_t *data, size_t len);
void I2C2_WriteNBytes(i2c2_address_t address, uint8_t* data, size_t len);
void I2C2_Write1ByteRegister(i2c2_address_t address, uint8_t reg, uint8_t data);
void I2C2_ReadNBytes(i2c2_address_t address, uint8_t* data, size_t len);

/*
                         Main application
 */
void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();

    // If using interrupts in PIC18 High/Low Priority Mode you need to enable the Global High and Low Interrupts
    // If using interrupts in PIC Mid-Range Compatibility Mode you need to enable the Global Interrupts
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();
    
    LATCbits.LATC4=1;
    LATCbits.LATC5=1;
    while (1)
    {
/*       
        I2C2_WriteNBytes(my_address,  &transArray[0], 0x81);
        I2C2_ReadDataBlock(my_address, SLAVE_EE_ADD, &RXArray[0], PACKET_SIZE);
__delay_ms(500);
*/
        // Add your application code

    /*    for(uint16_t i=0;i<4095;i++)
        {
            my_data=i;
        */
        __delay_ms(50);
       
        I2C2_WriteNBytes(my_address,my_array,3);
        //I2C2_ReadNBytes(my_address,my_array,3);
//        I2C2_Write1ByteRegister(0x60,0x40,0x09);

    //    I2C2_Write2ByteRegister(my_address,my_reg,my_data);
        __delay_ms(1000);
      //  }
  
        }
}
/**
 End of File
*/